/**
 *  '$RCSfile: LibraryIndexConceptItem.java,v $'
 *  '$Author: berkley $'
 *  '$Date: 2006/01/25 20:03:40 $'
 *  '$Revision: 1.3 $'
 *
 *  For Details:
 *  http://www.kepler-project.org
 *
 *  Copyright (c) 2004 The Regents of the
 *  University of California. All rights reserved. Permission is hereby granted,
 *  without written agreement and without license or royalty fees, to use, copy,
 *  modify, and distribute this software and its documentation for any purpose,
 *  provided that the above copyright notice and the following two paragraphs
 *  appear in all copies of this software. IN NO EVENT SHALL THE UNIVERSITY OF
 *  CALIFORNIA BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL,
 *  OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
 *  DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
 *  DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
 *  SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
 *  CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 *  ENHANCEMENTS, OR MODIFICATIONS.
 */

package org.kepler.objectmanager.library;

import org.kepler.objectmanager.lsid.KeplerLSID;

/**
 * A LibraryIndexComponent that implements the <ontology> tag.
   <LibraryIndex>
    <ontology name="" id="">
      <concept name="" id="">
        <concept name="" id="">
          ...
        </concept>

        <component name="" id=""/>
        <component name="" id=""/>
      </concept>

      <concept>
      </concept>

    </ontology>

    <ontology name="" id="">

    </ontology>

  </LibraryIndex>
 */
public class LibraryIndexConceptItem extends LibraryIndexItem
{ 
  String conceptId;
  /**
   * constructor.  this allows the creating of a new component.  
   * @param name the name of the component
   * @param lsid the lsid of the component.
   */
  public LibraryIndexConceptItem(String name, KeplerLSID lsid)
  {
    super(name, lsid);
    type = "concept";
  }
  
  public void setConceptId(String conceptId)
  {
    this.conceptId = conceptId;
  }
  
  public String getConceptId()
  {
    return conceptId;
  }
} 
