/* Program runner for Phylip PENNY.
 *
 * Copyright (c) 2005 Natural Diversity Discovery Project.
 * All rights reserved.
 * 
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 * 
 * IN NO EVENT SHALL THE NATURAL DIVERSITY DISCOVERY PROJECT BE LIABLE 
 * TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR 
 * CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE AND 
 * ITS DOCUMENTATION, EVEN IF THE NATURAL DIVERSITY DISCOVERY PROJECT
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE NATURAL DIVERSITY DISCOVERY PROJECT SPECIFICALLY DISCLAIMS ANY 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE NATURAL 
 * DIVERSITY DISCOVERY PROJECT HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

   @ProposedRating Red (tmcphillips@naturaldiversity.org)
   @AcceptedRating Red (tmcphillips@naturaldiversity.org) 
 */
 
package org.nddp.phylogeny.phylip;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import org.nddp.exceptions.CollectionException;
import org.nddp.exceptions.ExternalApplicationException;
import org.nddp.phylogeny.Tree;

public class PhylipPennyRunner extends PhylipTreeInferenceRunner {

    public PhylipPennyRunner() {
        
        super();
    }

	///////////////////////////////////////////////////////////////////
	////                         public methods                    ////    	

	public Object run() throws CollectionException {

    	    return _run("PENNY", System.getProperty("PHYLIP_EXE_DIR") + "/penny");
	}
	
	///////////////////////////////////////////////////////////////////
	////                         protected methods                 ////
    	
    protected void _writeStandardInput() 
    		throws ExternalApplicationException {
        
		try {
	    		// output total steps for each character
	    		_writeToProcess("4");		    		
		    
		    	// output all character states at each node of tree
		    	_writeToProcess("5");
		    	_writeToProcess(".");		    	

		} catch (IOException e) {
			throw new ExternalApplicationException(
		        "Error writing to PENNY process");
        	}
		
		super._writeStandardInput();
    }
}

